image: gitlab-registry.in2p3.fr/cta-lapp/phoenix_libs/phoenixhdf5/hdf5:0.3

stages:
- BuildTestinstall
- DocCoverage
- deploy

#- build
#- test
#- deploy

dailyBuildMasterAll:
    #cache:
        #untracked: true
        #paths:
        #- build/

    stage: BuildTestinstall
    script:
    - export LD_LIBRARY_PATH=/usr/lib
    - env
    - mkdir -p build
    - cd build
    - >
        cmake ..
        -DCMAKE_INSTALL_PREFIX=/usr
        -DRELEASE_MODE=yes
        -DSELF_TESTS_MODE=yes
    - make all
    - make install
    - make test
    only:
    - branches
    - tags
    tags:


TestCoverage:
    stage: DocCoverage
    script:
    - export LD_LIBRARY_PATH=/usr/lib
    - env
    - mkdir -p build coverage
    - cd build
    - >
        cmake ..
        -DCMAKE_INSTALL_PREFIX=/usr
        -DSELF_TESTS_MODE=yes
        -DCMAKE_BUILD_TYPE=Coverage
    - make all
    - make install
    - make test
    - make ExperimentalCoverage
    - cd ../coverage
    - gcovr -r ../ --html cov_report.html --html-details
    - gcovr -r ../ --xml Coverage.xml
    - gcovr -r ../
    artifacts:
        paths:
        - coverage
        expire_in: 1d
    only:
    - branches
    - tags
    tags:


Doc:
    stage: DocCoverage
    script:
    - export LD_LIBRARY_PATH=/usr/lib
    - env
    - git clone https://gitlab.in2p3.fr/CTA-LAPP/PHOENIX_LIBS/PhoenixTex2Html.git
    - cd PhoenixTex2Html
    - ./install.sh /usr
    - cd ..
    - rm -fr build public PhoenixTex2Html
    - mkdir -p build
    - mkdir -p public/html
    - cd build
    - >
        cmake ..
        -DCMAKE_INSTALL_PREFIX=/usr
        -DDOC_MODE=yes
        -DSELF_TESTS_MODE=no
    - make all
    - make doc
    - scp -r doc/platex/* ../public
    - scp -r doc/html/* ../public/html
    artifacts:
      paths:
      - public
      expire_in: 1d
    only:
    - branches
    - tags
    tags:


pages:
  stage: deploy
  script:
    - mv coverage public/
  artifacts:
    paths:
      - public
    expire_in: 1d

